CREATE TABLE CM2ICMPRIVS ( CMPRIVCODE SMALLINT NOT NULL,
                           ICMPRIVCODE INTEGER NOT NULL,
             PRIMARY KEY (CMPRIVCODE));
CREATE TABLE CM2ICMRMS( CMOSCODE SMALLINT NOT NULL,
                        ICMRMCODE SMALLINT NOT NULL,
             PRIMARY KEY (CMOSCODE));
CREATE TABLE CM2ICMCOLLECTIONS( CMOSCODE SMALLINT NOT NULL,
                                CMCOLLECTIONCODE SMALLINT NOT NULL,
                                ICMCOLLECTIONCODE SMALLINT NOT NULL,
             PRIMARY KEY (CMOSCODE, CMCOLLECTIONCODE));
CREATE VIEW SBTTOBEDEFCOLLS ( OSCODE, COLLCODE) AS
            SELECT OBJSERVCODE,
                   SMSCOLLCODE
            FROM SBTCOLLNAME EXCEPT
                  SELECT CMOSCODE,
                         CMCOLLECTIONCODE
                  FROM CM2ICMCOLLECTIONS;
CREATE TABLE CM2ICMACLS( CMACLCODE INTEGER NOT NULL,
                         ICMACLCODE INTEGER NOT NULL,
             PRIMARY KEY (CMACLCODE));
CREATE TABLE CM2ICMACLUSERS( CMACLCODE INTEGER NOT NULL,
                             CMUSERID INTEGER NOT NULL,
             PRIMARY KEY (CMACLCODE, CMUSERID));
CREATE VIEW SBTTOBEDEFACLUSERS ( ACLCODE, USERID) AS
            SELECT ACCESSLISTCODE,
                   USERID
            FROM SBTACCESSLIST
            WHERE ACCESSLISTCODE>0 EXCEPT
                  SELECT CMACLCODE,
                  CMUSERID
            FROM CM2ICMACLUSERS;
CREATE TABLE CM2ICMATTRS( CMATTRID SMALLINT NOT NULL,
                          ICMATTRID INTEGER NOT NULL,
             PRIMARY KEY (CMATTRID));
CREATE TABLE CM2ICMCLASSES( CMINDEXCLASSID SMALLINT NOT NULL,
                            ICMITEMTYPEID INTEGER NOT NULL,
             PRIMARY KEY (CMINDEXCLASSID));
CREATE TABLE CM2ICMROOTCOMPS( CMINDEXCLASSID SMALLINT NOT NULL,
                              ICMROOTCOMPID INTEGER NOT NULL,
             PRIMARY KEY (CMINDEXCLASSID));
CREATE TABLE CM2ICMCHILDCOMPS( MVTTABLENAME CHAR(13) NOT NULL,
                               ICMCHILDCOMPID INTEGER NOT NULL,
             PRIMARY KEY (MVTTABLENAME));
CREATE TABLE CM2ICMREPTYPES( CMREPTYPE CHAR(8) NOT NULL,
                             ICMREPID SMALLINT,
             PRIMARY KEY (CMREPTYPE));
CREATE TABLE CM2ICMLANGS( CMLANGCODE CHAR(3) NOT NULL,
             PRIMARY KEY (CMLANGCODE));
CREATE TABLE CM2ICMUSERS( CMUSERID INTEGER NOT NULL,
                          ICMUSERID CHAR(32) NOT NULL,
             PRIMARY KEY (CMUSERID));
CREATE TABLE CM2ICMGROUPS(USERID    CHAR(32) NOT NULL,
                          GROUPID   CHAR(32) NOT NULL,
             PRIMARY KEY (USERID,GROUPID));
CREATE VIEW SBTTOBEDEFGROUPS ( GROUPID, USERID) AS
            SELECT G.USERNAME,
                   U.USERNAME
            FROM SBTPATRONS G,
                 SBTPATRONS U,
                 SBTPATRONGROUP
            WHERE PATRONUSERID = U.USERID AND
                  GROUPUSERID = G.USERID EXCEPT
                     SELECT USERID,
                            GROUPID
                     FROM CM2ICMGROUPS;
CREATE TABLE CM2ICMWBS( CMWBITEMID  char(16) NOT NULL,
             PRIMARY KEY (CMWBITEMID));
CREATE TABLE CM2ICMWFS( CMWFITEMID  char(16) NOT NULL,
             PRIMARY KEY (CMWFITEMID));
CREATE TABLE CM2ICMCCS( CMCCLASS SMALLINT NOT NULL,
                        ICMMIMETYPEID INTEGER NOT NULL,
             PRIMARY KEY ( CMCCLASS));
CREATE TABLE CM2ICMVIEWS( CMVIEWID SMALLINT NOT NULL,
                          ICMVIEWID INTEGER NOT NULL,
             PRIMARY KEY (CMVIEWID));
CREATE TABLE CM2ICMREPLICARULES(
                   CMOSCODE        SMALLINT NOT NULL,
                   CMCOLLCODE      SMALLINT NOT NULL,
				   CMTRGTOSCODE    SMALLINT NOT NULL,
                   CMTRGTCOLLCODE  SMALLINT NOT NULL,

                   ICMRMCODE       SMALLINT NOT NULL,
				   ICMCOLLCODE     SMALLINT NOT NULL,
				   ICMTRGTRMCODE   SMALLINT NOT NULL,
                   ICMTRGTCOLLCODE SMALLINT NOT NULL,

                   PRIMARY KEY (CMOSCODE, CMCOLLCODE,
			                    CMTRGTOSCODE, CMTRGTCOLLCODE));

CREATE VIEW SBTTOBEDEFRULES ( CMOSCODE, CMCOLLCODE,
                              CMTRGTOSCODE, CMTRGTCOLLCODE) AS
         SELECT OBJSERVCODE, SMSCOLLCODE,
		        TARGETOBJSERVCODE, TARGETSMSCOLLCODE
         FROM SBTREPLICATE EXCEPT
              SELECT CMOSCODE, CMCOLLCODE,
			         CMTRGTOSCODE, CMTRGTCOLLCODE
              FROM CM2ICMREPLICARULES;

             